
#include "directry.ch"
   
PROCEDURE Main()

  LOCAL cKey  := "top-secret"
  LOCAL cFile
  LOCAL cTemp
  LOCAL aFiles

  SETMODE( 25,80 )
  CLS

   // Cleanning possible old files
   aFiles := DIRECTORY( "00_*.txt" )
  	AEVAL( aFiles, { |aFile| FERASE( aFile[ F_NAME ] ) } )

   // Selecting a file to test
   cFile := WIN_GETOPENFILENAME()
   IF EMPTY( cFile )
      ALERT( "You must to select a file" )
      QUIT
   ENDIF

   // Making a copy of the original file so we do not change anything by accident
   hb_fCopy( cFile, "00_Original.txt" )

   // Crypting the file
   cTemp := HB_MEMOREAD( "00_Original.txt" )
   cTemp := HB_MD5ENCRYPT( cTemp, "top-secret" ) 
   cTemp := hb_StrToHex( cTemp )
   HB_MEMOWRIT( "00_Encrypted.txt", cTemp )

   // Decrypting the file
   cTemp := HB_MEMOREAD( "00_Encrypted.txt" )
   cTemp := hb_HexToStr( cTemp )
   cTemp := HB_MD5DECRYPT( cTemp, "top-secret" ) 
   HB_MEMOWRIT( "00_Decrypted.txt", cTemp )

   ALERT( "Done!" )

RETURN

#pragma begindump
#include "hbapi.h"
#include "hbapiitm.h"
#include "hbchksum.h"

/*
 * Harbour Project source code:
 *    PRG functions for MD5 encryption/decryption using
 *    CFB (cipher feedback) mode
 *
 * Copyright 2011 Przemyslaw Czerpak <druzus / at / priv.onet.pl>
 * www - http://harbour-project.org
 */


static void hb_md5_init_seed( char * vect, const char * pszKey, int iLen )
{
   hb_md5( pszKey, iLen, vect );
}

static void hb_md5_next_seed( char * vect, const char * pszKey, int iLen )
{
   int i;
   for( i = 0; i < 16; ++i )
      vect[ i ] ^= pszKey[ i % iLen ];
   hb_md5( vect, 16, vect );
}

/* HB_MD5ENCRYPT( <cText>, <cPasswd> ) -> <cCipher>
 */
HB_FUNC( HB_MD5ENCRYPT )
{
   PHB_ITEM pData = hb_param( 1, HB_IT_STRING );

   if( pData && hb_parclen( 2 ) > 0 )
   {
      HB_SIZE nLen = hb_itemGetCLen( pData ), n;

      if( nLen )
      {
         const char * pszSource = hb_itemGetCPtr( pData );
         char * pszData = ( char * ) hb_xgrab( nLen + 1 );
         const char * pszKey = hb_parc( 2 );
         int iLen = ( int ) hb_parclen( 2 );
         char vect[ 16 ];

         hb_md5_init_seed( vect, pszKey, iLen );

         for( n = 0; n < nLen; ++n )
         {
            int i = ( int ) ( n & 0x0F );
            if( i == 0 )
               hb_md5_next_seed( vect, pszKey, iLen );
            pszData[ n ] = ( vect[ i ] ^= pszSource[ n ] );
         }
         hb_retclen_buffer( pszData, nLen );
      }
      else
         hb_retc_null();
   }
}

/* HB_MD5DECRYPT( <cCipher>, <cPasswd> ] ) -> <cText>
 */
HB_FUNC( HB_MD5DECRYPT )
{
   PHB_ITEM pData = hb_param( 1, HB_IT_STRING );

   if( pData && hb_parclen( 2 ) > 0 )
   {
      HB_SIZE nLen = hb_itemGetCLen( pData ), n;

      if( nLen )
      {
         const char * pszSource = hb_itemGetCPtr( pData );
         char * pszData = ( char * ) hb_xgrab( nLen + 1 );
         const char * pszKey = hb_parc( 2 );
         int iLen = ( int ) hb_parclen( 2 );
         char vect[ 16 ];

         hb_md5_init_seed( vect, pszKey, iLen );

         for( n = 0; n < nLen; ++n )
         {
            int i = ( int ) ( n & 0x0F );
            if( i == 0 )
               hb_md5_next_seed( vect, pszKey, iLen );
            pszData[ n ] = ( vect[ i ] ^ pszSource[ n ] );
            vect[ i ] = pszSource[ n ];
         }
         hb_retclen_buffer( pszData, nLen );
      }
      else
         hb_retc_null();
   }
}
#pragma enddump


/*
#include "directry.ch"
   
PROCEDURE Main()

  LOCAL cKey  := hb_blowfishkey( "test" )
  LOCAL cFile
  LOCAL cTemp
  LOCAL aFiles

  SETMODE( 25,80 )
  CLS

   // Cleanning possible old files
   aFiles := DIRECTORY( "00_*.txt" )
  	AEVAL( aFiles, { |aFile| FERASE( aFile[ F_NAME ] ) } )

   // Selecting a file to test
   cFile := WIN_GETOPENFILENAME()
   IF EMPTY( cFile )
      ALERT( "You must to select a file" )
      QUIT
   ENDIF

   // Making a copy of the original file so we do not change anything by accident
   hb_fCopy( cFile, "00_Original.txt" )

   // Crypting the file
   cTemp := HB_MEMOREAD( "00_Original.txt" )
   cTemp := hb_blowfishEncrypt( cKey, cTemp )
   cTemp := hb_StrToHex( cTemp )
   HB_MEMOWRIT( "00_Encrypted.txt", cTemp )

   // Decrypting the file
   cTemp := HB_MEMOREAD( "00_Encrypted.txt" )
   cTemp := hb_HexToStr( cTemp )
   cTemp := hb_blowfishDecrypt( cKey, cTemp )
   HB_MEMOWRIT( "00_Decrypted.txt", cTemp )

   ALERT( "Done!" )

RETURN

*/